#! /usr/bin/env python 
#coding=utf8

import os
import numpy as np
from matplotlib import rc, rcParams
import matplotlib.pyplot as plt
import matplotlib.ticker as ticker
from matplotlib.ticker import AutoMinorLocator

p = '/home/slisakov/Desktop/'
pref = ''
i=1
os.chdir(p)
def sf():
    global i

    #pdf = pref+str(i) + '.pdf'
    #ps  = pref+str(i) + '.ps'
    #plt.savefig(pdf, bbox_inches='tight')
    #os.system('pdf2ps {}'.format(pdf))  # This 'conversion' reduces
    #os.system('ps2pdf {}'.format(ps))   # file size from ~200kB to ~15kB
    #os.system('rm {}'.format(ps))
    #print(pdf, 'saved')

    #png = pref+"{:02d}".format(i)
    #plt.savefig(png, bbox_inches='tight')
    #print(png, 'saved')

    i+=1

# Оптические параметры
l=100       # ГОО           
x_lens=0    # Центр линзы
y_lens=54   # Длина линзы
hl=4
hw=3
 
# Настройка графика
lw = 1.1
ms = 3
c  = '#2266FF'
fs=14
rc('font', family='serif')
rc('font', size=fs)
rc('text', usetex=True)
fig = plt.figure()
ax = plt.subplot(111)
lim=1.4
ymax=1.5
ymin=1.2
#ax.set_xlim([-l*lim,      l*0.75])
#ax.set_ylim([-y_lens*ymin, y_lens*ymax])
ax.set_xlim([-100, 65])
ax.set_ylim([-65,  75])
ax.axis('off')
ax.set_aspect('equal')
#fig.subplots_adjust(left=.15, bottom=.15, right=.95, top=.95)

# ГОО
x1 = [-l,l]
y1 = [0, 0]
ax.plot(x1, y1, 'k', lw=lw)

# Координаты источника и изображения
xs = -85
ys =  49
xi = -35
d  = -xs
h  = ys
f  = xi     # f — расстояние от линзы до изображения. Собирающая, действ. изобр.
G  = f/d    # линейное увеличение
# Расчёт F
yi = -h*G
dy = yi-ys
dx = xi
k  = dy/dx
b  = ys
x  = [0, 1.5*xi]
y  = [k*x[0]+b,  k*x[1]+b]
F = -b/k

# Предмет
ax.arrow(-d, 0, 0, h, fc='tab:blue', ec='tab:blue', head_width=hw, head_length=hl, length_includes_head=True, lw=lw)
ax.text(-d-l/20, h/2+l/30, '$h$', ha='center', va='top')

# Линза
ax.plot([x_lens,x_lens],[-y_lens,y_lens],'k',lw=lw, zorder=0)
dx=2
dy=6
x=[x_lens,0-dx]
y=[-y_lens,-y_lens-dy]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens+dx]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens-dx]
y=[y_lens,y_lens+dy]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens+dx]
ax.plot(x,y,'k',lw=lw)

# Левый фокус
ax.plot(-F,     y1[0],    'o',  ms=ms, c='k')
#ax.text (-F*1.04, y1[0]-3, '$F$', horizontalalignment='right', verticalalignment='top', fontsize=fs*0.75)
# Правый фокус
ax.plot(F,     x_lens,    'o',  ms=ms, c='k')
ax.text (F, x_lens+1, '$F$', horizontalalignment='right', verticalalignment='bottom', fontsize=fs*0.75)
sf()

k3=0.75
# <-> d
ax.plot([-d, -d], [0, -h*k3], 'k--', lw=lw/2)
ax.annotate(s='', xy=(-d, -h*k3), xytext=(0, -h*k3), arrowprops=dict(arrowstyle='<->'))
ax.text(xs/2, -(ys*k3+l/20), '$d$', ha='center', va='top')
sf()

# Луч через центр #1
dy = yi-ys
dx = xs-xi
k  = -dy/dx
b  = 0
x  = [xs, -0.5*xi]
y  = [k*x[0]+b,  k*x[1]+b]
ax.plot(x,y, c='tab:blue', lw=lw)
ax.text(x[1], y[1], '$1$')
sf()

### Расчёт коэф. наклона k
##k=ys/xs
##x=[1.0*xs,  2*xi]
##y=[k*x[0],  k*x[1]]

# Луч параллельный из источника
ax.plot([xs,0], [ys,ys], c='tab:blue', lw=lw)
sf()
## Его продолжение в левый фокус
k=-h/F
x=[0,           F]
y=[k*x[0]+h,  k*x[1]+h]
ax.plot(x,y, c='tab:blue', lw=lw, ls='--')
sf()
## Его продолжение после линзы (преломился)
k=-h/F
x=[0,           -xi*0.8]
y=[k*x[0]+h,  k*x[1]+h]
ax.plot(x,y, c='tab:blue', lw=lw)
ax.text(x[1], y[1], '$2$', va='top')
sf()


# Изображение
yi = k*xi
ax.arrow(f, 0, 0, -h*G, fc='tab:orange', ec='tab:orange', head_width=hw, head_length=-hl*G, length_includes_head=True, lw=lw)
ax.text(f+l/40, -h*G/2, '$h^\prime$', ha='left', va='center_baseline')
sf()
# <-> f
k3=0.3
ax.plot([xi, xi], [0, -h*k3], 'k--', lw=lw/2)
ax.annotate(s='', xy=(0, -h*k3), xytext=(f, -h*k3), arrowprops=dict(arrowstyle='<->'))
ax.text(xi/2, -(ys*k3+l/20), '$f$', ha='center', va='top')
sf()

# <-> F-f
ax.plot([F, F], [0, -h*k3], 'k--', lw=lw/2)
ax.annotate(s='', xy=(F, -h*k3), xytext=(f, -h*k3), arrowprops=dict(arrowstyle='<->'))
ax.text((F+f)/2, -(ys*k3+l/20), '$F-f$', ha='center', va='top')
sf()

# Разметка треугольников
##O
ax.plot(0, 0, 'ko', ms=ms, )
ax.text(0+l/50, 0+l/50, '$O$', ha='left', va='bottom', fontsize=fs*0.8)
##A
x=-d
y=h
ax.plot(x, y, 'ko', ms=ms, )
ax.text(x+l/50, y+l/50, '$A$', ha='right', va='bottom', fontsize=fs*0.8)
##B
x=-d
y=0
ax.plot(x, y, 'ko', ms=ms, )
ax.text(x-l/50, y-l/50, '$B$', ha='right', va='top', fontsize=fs*0.8)
##A'
x=f
y=-h*G
ax.plot(x, y, 'ko', ms=ms, )
ax.text(x+l/50, y+l/50, '$A^\prime$', ha='center', va='bottom', fontsize=fs*0.8)
##B'
x=f
y=0
ax.plot(x, y, 'ko', ms=ms, )
ax.text(x+l/20, y-l/40, '$B^\prime$', ha='center', va='top', fontsize=fs*0.8)
##L
x=0
y=h
ax.plot(x, y, 'ko', ms=ms, )
ax.text(x+l/50, y-l/50, '$L$', ha='left', va='top', fontsize=fs*0.8)
sf()

## <-> h' справа
ax.plot([0,d/4], [h,h], 'k--', lw=lw/2 )
ax.annotate(s='', xy=(d/4, 0), xytext=(d/4, h), arrowprops=dict(arrowstyle='<->'))
ax.text(d/4+l/30, h/2, '$h$',va='center')
sf()

plt.show()
